package com.android.imamotive;

import com.android.imamotive.BluetoothLeService;
import android.annotation.SuppressLint;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.BroadcastReceiver;
import android.content.ComponentName;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.ServiceConnection;
import android.os.Bundle;
import android.os.Environment;
import android.os.IBinder;
import android.os.SystemClock;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup.LayoutParams;
import android.widget.Button;
import android.widget.Chronometer;
import android.widget.RelativeLayout;
import android.widget.TableLayout;
import android.widget.TextView;
import android.widget.Toast;

import java.io.File;
import java.io.UnsupportedEncodingException;
import java.text.SimpleDateFormat;
import java.util.Date;

/**
 * For a given BLE device, this Activity provides the user interface to connect, display data,
 * and display GATT services and characteristics supported by the device.  The Activity
 * communicates with {@code BluetoothLeService}, which in turn interacts with the
 * Bluetooth LE API.
 */
public class DeviceControlActivity extends Activity {
    private final static String TAG = DeviceControlActivity.class.getSimpleName();
    public static final String EXTRAS_DEVICE_NAME = "DEVICE_NAME";
    public static final String EXTRAS_DEVICE_ADDRESS = "DEVICE_ADDRESS";     
    private String mDeviceAddress;
    private BluetoothLeService mBluetoothLeService;   
    //Ecriture lecture fichier    
    final String LOG_TAGE = "SDactivity memoire externe";    
    String monFichier;    
    //Entrainement layout
	RelativeLayout rl;
	Chronometer focus;
	Button start, stop, pause, reprendre;
	TextView mTemperature, mCardiaque, mNbPas, mNbKm;
	TableLayout mtablelayout;
	long timeWhenStopped = 0;    
    // Code to manage Service lifecycle.
    private final ServiceConnection mServiceConnection = new ServiceConnection() {
        @Override
        public void onServiceConnected(ComponentName componentName, IBinder service) {
        	//On affiche le bouton start une fois connecte????
        	start.setVisibility(View.VISIBLE);
            mBluetoothLeService = ((BluetoothLeService.LocalBinder) service).getService();
            if (!mBluetoothLeService.initialize()) {
                Log.e(TAG, "Unable to initialize Bluetooth");
                finish();
            }
            // Automatically connects to the device upon successful start-up initialization.
            mBluetoothLeService.connect(mDeviceAddress);
        }
        @Override
        public void onServiceDisconnected(ComponentName componentName) {
            mBluetoothLeService = null;
        }
    };
    // Handles various events fired by the Service.
    // ACTION_GATT_CONNECTED: connected to a GATT server.
    // ACTION_GATT_DISCONNECTED: disconnected from a GATT server.
    // ACTION_GATT_SERVICES_DISCOVERED: discovered GATT services.
    // ACTION_DATA_AVAILABLE: received data from the device.  This can be a result of read
    //    or notification operations.
    private final BroadcastReceiver mGattUpdateReceiver = new BroadcastReceiver() {
        @Override
        public void onReceive(Context context, Intent intent) {
            final String action = intent.getAction();
            
            if (BluetoothLeService.ACTION_GATT_CONNECTED.equals(action)) 
            {              
                //Code nrf               
           	 	runOnUiThread(new Runnable() {
           	 		public void run() {

                        Log.d(TAG, "UART_CONNECT_MSG");            	                 	 	               	 	
                  	 	
                  	 	byte[] value;
                  	 	String message = "0";
                  	 	try {
							value = message.getBytes("UTF-8");
							mBluetoothLeService.writeRXCharacteristic(value);
						} catch (UnsupportedEncodingException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}                  	 	
                    }
           	 	});
            }
            else if (BluetoothLeService.ACTION_GATT_DISCONNECTED.equals(action)) 
            {
           	 	runOnUiThread(new Runnable() {
                 public void run() {
                         Log.d(TAG, "UART_DISCONNECT_MSG");
                         mBluetoothLeService.close();
                 }
           	 	});
           	 	invalidateOptionsMenu();
            }
            else if (BluetoothLeService.ACTION_GATT_SERVICES_DISCOVERED.equals(action)) 
            {
            	Log.d(TAG, "UART_ACTION_GATT_SERVICES_DISCOVERED");
            	mBluetoothLeService.enableTXNotification();       	   
            }
            else if (BluetoothLeService.ACTION_DATA_AVAILABLE.equals(action)) 
            {
            	Log.d(TAG, "ACTION_DATA_AVAILABLE");
            	final byte[] txValue = intent.getByteArrayExtra(BluetoothLeService.EXTRA_DATA);            	                       	            	
                runOnUiThread(new Runnable() {
                    public void run() {
                        try {             	
                        	int bitStart = (int) txValue[0] & 0xff; //Conversion en unsignedint
                        	int bitStop = (int) txValue[8] & 0xff;                        	                        
                        	long time = focus.getBase() - SystemClock.elapsedRealtime();     
                        	
                        	int hours = (int) (time / 3600000);
                        	int minutes = (int) (time - hours * 3600000) / 60000;
                        	int seconds = (int) (time - hours * 3600000 - minutes * 60000) / 1000;
                        	int timeTotal = (hours*3600) + (minutes*60) + seconds; //allez savoir pourquoi la valeur total est ngative
                        	
                        	float temperature = 0;
                        	int pas = 0;                        	
                        	
                        	if(bitStart == 192 && bitStop == 193 )
                        	{
                        		float bit1 = (int) txValue[1] & 0xff;//temprature unit
                        		float bit2 = (int) txValue[2] & 0xff;//temprature centime
                        		int freq = (int) txValue[3] & 0xff;//frequence
                        		int bit4 = (int) txValue[4] & 0xff;//pas millieme
                        		int bit5 = (int) txValue[5] & 0xff;//pas centaine
                        		int bit6 = (int) txValue[6] & 0xff;//pas dizaine
                        		int bit7 = (int) txValue[7] & 0xff;//pas unite                        		                 	                        		
                        		
                        		temperature = bit1+(bit2/100);
                        		pas = bit4*1000+bit5*100+bit6*10+bit7;
                        		
	                       	 	String donnee = String.valueOf(-timeTotal) + " " + String.valueOf(temperature)+ " " + String.valueOf(freq) + " " + String.valueOf(pas);
	                       	 	
	                       	 	FileClass.ecrireFichierE(monFichier + ".txt", donnee);
	                       	 	
	                       	 	mTemperature.setText(String.valueOf(temperature));	                       	 
	                       	 	mCardiaque.setText(String.valueOf(freq));	                       	 	
	                       	 	mNbPas.setText(String.valueOf(pas));
		                       	 	
	                       	 	int nbCm = pas*70;
		                	     
		                	    int nbKm = nbCm/100000;
		                	    int nbM = (nbCm-nbKm*100000)/100;
		                	     
		                	    String Distance;
		                	    if(nbKm>0)
		                	    	Distance = Integer.toString(nbKm) +","+ Integer.toString(nbM) + " km";
		                	    else if(nbM>0)
		                	    	Distance = Integer.toString(nbM)+ "," + Integer.toString(nbCm-(nbM*100)) + " m";
		                	    else
		                	    	Distance = Integer.toString(nbCm)+"cm";
	                       	 	mNbKm.setText(Distance);
	                       	 	
                        	}
                        } catch (Exception e) {
                            Log.e(TAG, e.toString());
                        }
                    }
                });
            }
            if (action.equals(BluetoothLeService.DEVICE_DOES_NOT_SUPPORT_UART)){
            	showMessage("Device doesn't support UART. Disconnecting");
            	mBluetoothLeService.disconnect();
            }
        }
    };    
    private void showMessage(String msg) {
        Toast.makeText(this, msg, Toast.LENGTH_SHORT).show();
    }
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);        
	    setContentView(R.layout.entrainementlayout);
	    getActionBar().setTitle("Entrainement");
	    
	    rl = (RelativeLayout) findViewById(R.id.layoutentr);
	    
	    start = (Button) findViewById(R.id.button_start);
	    stop = (Button) findViewById(R.id.button_stop);
	    pause = (Button) findViewById(R.id.button_pause);
	    reprendre = (Button) findViewById(R.id.button_reprendre);
        mTemperature = (TextView) findViewById(R.id.text_temperature);
        mCardiaque = (TextView) findViewById(R.id.text_cardiaque);
        mNbPas = (TextView) findViewById(R.id.text_nbpas);
        mNbKm  = (TextView) findViewById(R.id.text_km);
        mtablelayout = (TableLayout) findViewById(R.id.tablelayout);
	   
	    focus = new Chronometer (DeviceControlActivity.this);
	    
	    RelativeLayout.LayoutParams params = new RelativeLayout.LayoutParams ((int) LayoutParams.WRAP_CONTENT, (int) LayoutParams.WRAP_CONTENT);

	    params.addRule(RelativeLayout.CENTER_IN_PARENT);
	    	   
	    focus.setLayoutParams(params);
	    
	    rl.addView(focus);
	    
	    //On cache tout puis on affiche start lorsque c'est connecte
	    
	    start.setVisibility(View.VISIBLE);
	    focus.setVisibility(View.GONE);
	    stop.setVisibility(View.GONE);
	    pause.setVisibility(View.GONE);
	    reprendre.setVisibility(View.GONE);
	    mtablelayout.setVisibility(View.GONE);
	    	    	    
        Intent gattServiceIntent = new Intent(this, BluetoothLeService.class);
        bindService(gattServiceIntent, mServiceConnection, BIND_AUTO_CREATE);               

        //AlertDialog//        
        //On instancie notre layout en tant que View
	    LayoutInflater factory = LayoutInflater.from(this);
        final View alertDialogView = factory.inflate(R.layout.alertdialogperso, null);
      //Cration de l'AlertDialog
        final AlertDialog.Builder adb = new AlertDialog.Builder(this);
      //On affecte la vue personnalis que l'on a cre  notre AlertDialog
        adb.setView(alertDialogView);
        //On donne un titre  l'AlertDialog
        adb.setTitle("Entrainement termin");                
      //On affecte un bouton type "OK"  notre AlertDialog et on lui affecte un vnement
        adb.setPositiveButton("Sauvegarder", new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface dialog, int which) {
            	//Cration de l'intent pour passer  l'activit "Stat_Activity"
            	Intent secondeActivite = new Intent(DeviceControlActivity.this, Stat_Activity.class);
            	//On indique quelle fichier doit traiter l'activit en lui passant son nom en paramtre
        		secondeActivite.putExtra(Stat_Activity.EXTRAS_ID_FILE,monFichier+".txt");
        		startActivity(secondeActivite);
        		DeviceControlActivity.this.finish();
          } });        
        //On cre un bouton de type "Annuler"  notre AlertDialog et on lui affecte un vnement
        adb.setNegativeButton("Supprimer", new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface dialog, int which) {
            	//On supprime le fichier qui vient d'tre cr
            	File sdLien = Environment.getExternalStorageDirectory();
            	File Fichier = new File(sdLien + File.separator + "Projet_Tshirt"+ File.separator + monFichier+".txt");
            	Log.d("Fichier SD",	"path de fichier:"	+ monFichier);
            	if(!Fichier.exists()) {
            		throw new RuntimeException("Fichier innxistant dur la carte sd");
            	}            
            	Fichier.delete();
            	//Lorsque l'on cliquera sur annuler on quittera l'application
            	finish();
          } });                        
	    //Lancement des calculs
	    start.setOnClickListener(new View.OnClickListener() {
	    	@SuppressLint("SimpleDateFormat") @Override
	    	public void onClick(View v) {
	    		// TODO Auto-generated method stub
	    		stop.setVisibility(View.VISIBLE);
	    		pause.setVisibility(View.VISIBLE);
	    		focus.setVisibility(View.VISIBLE);
	    		mtablelayout.setVisibility(View.VISIBLE);
	    		start.setVisibility(View.GONE);
	    		
	    		mTemperature.setText("---");
	    		mCardiaque.setText("---");
	    		mNbPas.setText("---");
	    		mNbKm.setText("---");
	    		
	    		reprendre.setVisibility(View.GONE);
	    		timeWhenStopped = 0; //securite
	    		focus.setBase(SystemClock.elapsedRealtime());
	    		focus.start();
	    		
                //connection au T-shirt    		
                registerReceiver(mGattUpdateReceiver, makeGattUpdateIntentFilter());
                if (mBluetoothLeService != null) {
                    final boolean result = mBluetoothLeService.connect(mDeviceAddress);
                    Log.d(TAG, "Connect request result=" + result);
                }
                
                //Rcupration de l'adresse du Device
                final Intent intent = getIntent();
                mDeviceAddress = intent.getStringExtra(EXTRAS_DEVICE_ADDRESS);
                mBluetoothLeService.connect(mDeviceAddress);                                
                
                //Envoie d'un message au T-shirt pour lui demander l'envoie de ces donnes
            	String message = "1";
            	byte[] value;
				try {
					//Envoie des datas au service
					value = message.getBytes("UTF-8");					
					mBluetoothLeService.writeRXCharacteristic(value);
				} catch (UnsupportedEncodingException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}	    
				
				//Cration du fichier en nommant le String "monFichier"
   	 			SimpleDateFormat formatter = new SimpleDateFormat("yy_MM_dd_HH_mm_ss");
   	 			String currentDateTimeString = formatter.format(new Date());
                //Ecrire la donne recu dans une variable string globale pour ensuitre ecrire dans le fichier une fois la connection arrete
            	monFichier = currentDateTimeString;
           	 	Log.i(LOG_TAGE, "nom de fichier:" + monFichier); //current date string sera le nom du fichier  							        		
	    	}
	    });	    	   
	    
	    //Reprise des calculs
	    reprendre.setOnClickListener(new View.OnClickListener() {
	    	@Override
	    	public void onClick(View v) {
	    		// TODO Auto-generated method stub
	    		reprendre.setVisibility(View.GONE);
	    		pause.setVisibility(View.VISIBLE);
	    		
	    		focus.setBase(SystemClock.elapsedRealtime() + timeWhenStopped);
	    		focus.start();
	    		mBluetoothLeService.connect(mDeviceAddress);
	    	}
	    });	    
	    pause.setOnClickListener(new View.OnClickListener() {			
	    	@Override
	    	public void onClick(View v) {
	    		// TODO Auto-generated method stub
	    		pause.setVisibility(View.GONE);
	    		reprendre.setVisibility(View.VISIBLE);
	    		
	    		timeWhenStopped = focus.getBase() - SystemClock.elapsedRealtime();
	    		focus.stop();
	    		mBluetoothLeService.disconnect();
	    	}
	    });	    
	    //Arret des calculs, on demande  lutilisateur sil souhaite arreter lentrainement puis go Stat_actvity
	    stop.setOnClickListener(new View.OnClickListener() {			
	    	@Override
	    	public void onClick(View v) {
	    		// TODO Auto-generated method stub	    		   	    	
	    		timeWhenStopped = focus.getBase() - SystemClock.elapsedRealtime();//On recupere le temps final pour lenvoyer dans la bdd	    		
	    		focus.stop();
	    		focus.setBase(SystemClock.elapsedRealtime());	    			  	    		
	    		//Disconnect button pressed
	    		mBluetoothLeService.disconnect();
	    		adb.show();
	    	}
	    });	       	    
    }        
    @Override
    protected void onResume() {
        super.onResume();
        Log.d(TAG, "onResume");
        registerReceiver(mGattUpdateReceiver, makeGattUpdateIntentFilter());
        if (mBluetoothLeService != null) {
            final boolean result = mBluetoothLeService.connect(mDeviceAddress);
            Log.d(TAG, "Connect request result=" + result);
        }
    }
    @Override
    protected void onPause() {
        super.onPause();
        unregisterReceiver(mGattUpdateReceiver);
    }
    @Override
    protected void onDestroy() {
        super.onDestroy();
        unbindService(mServiceConnection);
        mBluetoothLeService = null;
    }
    private static IntentFilter makeGattUpdateIntentFilter() {
        final IntentFilter intentFilter = new IntentFilter();
        intentFilter.addAction(BluetoothLeService.ACTION_GATT_CONNECTED);
        intentFilter.addAction(BluetoothLeService.ACTION_GATT_DISCONNECTED);
        intentFilter.addAction(BluetoothLeService.ACTION_GATT_SERVICES_DISCOVERED);
        intentFilter.addAction(BluetoothLeService.ACTION_DATA_AVAILABLE);
        return intentFilter;
    }
}
