package com.android.imamotive;

import com.jjoe64.graphview.GraphView;
import com.jjoe64.graphview.series.DataPoint;
import com.jjoe64.graphview.series.LineGraphSeries;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;


public class Stat_Activity extends Activity{
	public static final String EXTRAS_ID_FILE = "ID_FILE";
	String Id_File;
	Button button_Temp,button_Card;
	TextView mDate, mHeure, mTime, mTemp, mCard, mNbPas, mnbKm;
	@Override
	public void onCreate(Bundle savedInstanceState) {
	    super.onCreate(savedInstanceState);
	    setContentView(R.layout.statlayout);
	    getActionBar().setDisplayHomeAsUpEnabled(true);	 
	    
	    mDate = (TextView) findViewById(R.id.text_date);
	    mHeure = (TextView) findViewById(R.id.text_heure);
	    mTime = (TextView) findViewById(R.id.text_time);
	    mTemp = (TextView) findViewById(R.id.text_temperature);
	    mCard = (TextView) findViewById(R.id.text_cardiaque);
	    mNbPas = (TextView) findViewById(R.id.text_nbpas);
	    mnbKm = (TextView) findViewById(R.id.text_km);
	    
        button_Temp = (Button) findViewById(R.id.button_temp);
        button_Card = (Button) findViewById(R.id.button_card);
	    	  
	    //rcupration du fichier  analyser:
	    final Intent secondeActivite = getIntent();
	    Id_File = secondeActivite.getStringExtra(EXTRAS_ID_FILE);
	    	    
	    String[] dateSplit;
	    String Id_ , date, heure;
	    
	    Id_ = Id_File.substring(0,Id_File.indexOf('.'));
	    
	    dateSplit = Id_.split("_");
	    
	    date = dateSplit[2] + "/" + dateSplit[1] + "/" + dateSplit[0] ; 
	    heure = dateSplit[3] + ":" + dateSplit[4] + ":" + dateSplit[5];
	    mDate.setText(date);
	    mHeure.setText(heure);

	    //On rcupre le nombre de ligne  
        int nbLineText = FileClass.countLineFichierE(Id_File);
        Log.i("Stat","Nombres de ligne du fichier: "+ nbLineText);	    
	    
	     String[] textColonne,textLigne; //Tableau de string pour chaque ligne et chaque colonne 
	     //On rcupre chaque ligne du fichier
	     textLigne = FileClass.lireFichierE(Id_File);
	     
	     int  cardMoy = 0;
	     float tempMoy = 0;
	     
	     String timeTotal="", nbPasTotal="";
	     
	     int[] timeTable = new int[nbLineText]; //Tableau regroupant toutes les valeur de temps lu dans le fichier
	     float[] tempTable = new float[nbLineText]; //Toutes les valeurs de temprature 
	     int[] cardTable = new int[nbLineText]; //Valeurs de la frquence cardiaque
	     
	   //Boucle pour parcourir le fichier ligne par ligne
	     for (int x=0; x<nbLineText; x++) 
	     {	        
	    	//On rcupre les colonnes en splitant le string ligne
	    	 String ligne = textLigne[x];	    	 
	    	 textColonne = ligne.split("\\s");	    	 
	    	     	 
	    	 //TEMPS
	    	 timeTable[x] = Integer.parseInt(textColonne[0]);	    	 
	    	 Log.i("Colonne","Time : "+ timeTable[x]);
	    	 
	    	 //TEMPERATURE
	    	 tempMoy += Float.parseFloat(textColonne[1]);
	    	 tempTable[x] = Float.parseFloat(textColonne[1]);
	    	 Log.i("Colonne","Temperature : "+ tempTable[x]);
	    	 
	    	 //FREQUENCE CARDIAQUE
	    	 cardMoy += Integer.parseInt(textColonne[2]);
	    	 cardTable[x] = Integer.parseInt(textColonne[2]);
	    	 Log.i("Colonne","textColonne : "+ cardTable[x]);
	    	 
	    	 //DERNIER LIGNE
	    	 if(x==(nbLineText-1))
	    	 {
	    		 timeTotal = textColonne[1];	    		 
	    		 nbPasTotal = textColonne[3];
	    	 }	    	  
	     }	     	    
	     	     
	     String Time = ConverTime(timeTotal); // Cette fonction est dfinie plus bas dans le fichier.
	     
	     mTime.setText(Time);
	     mNbPas.setText(nbPasTotal);	
	     
	     int nbCm = Integer.parseInt(nbPasTotal)*70;
	     
	     int nbKm = nbCm/100000;
	     int nbM = (nbCm-nbKm*100000)/100;
	     
 	    String Distance;
 	    if(nbKm>0)
 	    	Distance = Integer.toString(nbKm) +","+ Integer.toString(nbM) + " km";
 	    else if(nbM>0)
 	    	Distance = Integer.toString(nbM)+ "," + Integer.toString(nbCm-(nbM*100)) + " m";
 	    else
 	    	Distance = Integer.toString(nbCm)+"cm";
 	    
	     mnbKm.setText(Distance);

	     //Temprature et rythme cardiaque moyenne:
	     tempMoy = tempMoy/nbLineText;
	     String tempMoyString = Float.toString(tempMoy); 
	     
	     tempMoyString = tempMoyString.substring(0,5);
	     
	     mTemp.setText(tempMoyString + "C");
	     	   
	     cardMoy = cardMoy/nbLineText;
	     String cardMoyString = Integer.toString(cardMoy);
	     mCard.setText(cardMoyString);	    
	     
	     //Graph de la frquence par rapport au temps	    
	     final GraphView graph_card = (GraphView) findViewById(R.id.graph_card);
	     LineGraphSeries<DataPoint> series_card = null;	     
	     DataPoint[] dataPoint = new DataPoint[nbLineText];	     
	     for (int x=0; x<nbLineText; x++)
	     {		    		     
		     dataPoint[x] = new DataPoint(timeTable[x],cardTable[x]); 		     
	     }
	     series_card = new LineGraphSeries<DataPoint>(dataPoint);	     
	     graph_card.setTitle("Frquence cardiaque");	     
	     graph_card.addSeries(series_card);	     	     
	     graph_card.setVisibility(View.VISIBLE);
	     
	     //Graph de la temprature par rapport au temps	     	    
	     final GraphView graph_temp = (GraphView) findViewById(R.id.graph_temp);
	     LineGraphSeries<DataPoint> series_temp = null;	     
	     DataPoint[] dataPoint2 = new DataPoint[nbLineText];	     
	     for (int x=0; x<nbLineText; x++)
	     {		    		     
		     dataPoint2[x] = new DataPoint(timeTable[x],tempTable[x]); 		     
	     }
	     series_temp = new LineGraphSeries<DataPoint>(dataPoint2);	     
	     graph_temp.setTitle("Temprature du corps (C)");     	     
	     graph_temp.addSeries(series_temp);	 	 
	     
	     graph_temp.setVisibility(View.GONE);	     
	     button_Card.setVisibility(View.GONE);	     	     
	     button_Card.setOnClickListener(new View.OnClickListener() {				
				@Override
				public void onClick(View v) {
					graph_card.setVisibility(View.VISIBLE);
					graph_temp.setVisibility(View.GONE);
					
					button_Card.setVisibility(View.GONE);
					button_Temp.setVisibility(View.VISIBLE);
				}
			});
	     button_Temp.setOnClickListener(new View.OnClickListener() {				
				@Override
				public void onClick(View v) {
					graph_card.setVisibility(View.GONE);
					graph_temp.setVisibility(View.VISIBLE);						
					button_Card.setVisibility(View.VISIBLE);
					button_Temp.setVisibility(View.GONE);
				}
			});	     	     	          	    
	}		
	//Fonction permettant de convertir le temps "00:00" en seconde de type int
	//Attention, l'exercice doit durer moins d'une heure!!	
    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch(item.getItemId()) {
            case android.R.id.home:
                onBackPressed();
                return true;
        }
        return super.onOptionsItemSelected(item);
    }			
	public String ConverTime(String time)
	{
		String timeString;
		int secondes = Integer.parseInt(time);		
		int heure, minute;		
		heure = secondes/3600;
		minute = (secondes-(heure*3600))/60;		
		secondes = secondes - (heure*3600) - (minute*60);		
		if (heure > 0)
			timeString = Integer.toString(heure)+":"+Integer.toString(minute)+":"+Integer.toString(secondes);
		else if (minute > 0)
			timeString = Integer.toString(minute)+":"+Integer.toString(secondes);
		else
			timeString = Integer.toString(secondes)+ " secondes";
		return timeString;
	}		
}
